#line 1 "parse.xy"
/*
#line 2 "parse.xy"
 * Zeta.  New simple compiled language
#line 3 "parse.xy"
 *   (because there weren't enough already!)
#line 4 "parse.xy"
 */
#line 5 "parse.xy"
%{

#line 6 "parse.xy"
#include "a.h"
#line 7 "parse.xy"
#include "type.h"
#line 8 "parse.xy"
#include "runtime.h"
#line 9 "parse.xy"
#include "compile.h"
#line 10 "parse.xy"

#line 11 "parse.xy"
Pos yylastpos;
#line 12 "parse.xy"

#line 13 "parse.xy"
#define YYLLOC_DEFAULT(Current, Rhs, N)					\
	do{								\
		if(N){							\
			(Current).start = YYRHSLOC(Rhs, 1).start;	\
			(Current).end = YYRHSLOC(Rhs, N).end;		\
		}else{							\
			(Current).start = (Current).end =		\
				YYRHSLOC(Rhs, 0).end;			\
		}							\
		yylastpos = (Current);					\
	} while(0)							\

#line 25 "parse.xy"
#define YYSTYPE Yystype
#line 26 "parse.xy"
#define YYLTYPE Pos
#line 27 "parse.xy"

#line 28 "parse.xy"
static Expr*
#line 29 "parse.xy"
ebinary(Name name, Expr *e1, Expr *e2)
#line 30 "parse.xy"
{
#line 31 "parse.xy"
	Expr *e;
#line 32 "parse.xy"
	
#line 33 "parse.xy"
	e = mkExpr(ExprBinary);
#line 34 "parse.xy"
	e->name = name;
#line 35 "parse.xy"
	e->e1 = e1;
#line 36 "parse.xy"
	e->e2 = e2;
#line 37 "parse.xy"
	return e;
#line 38 "parse.xy"
}
#line 39 "parse.xy"

#line 40 "parse.xy"
static Expr*
#line 41 "parse.xy"
ebinaryeq(Name name, Expr *e1, Expr *e2)
#line 42 "parse.xy"
{
#line 43 "parse.xy"
	Expr *e;
#line 44 "parse.xy"
	
#line 45 "parse.xy"
	e = mkExpr(ExprBinaryEq);
#line 46 "parse.xy"
	e->name = name;
#line 47 "parse.xy"
	e->e1 = e1;
#line 48 "parse.xy"
	e->e2 = e2;
#line 49 "parse.xy"
	return e;
#line 50 "parse.xy"
}
#line 51 "parse.xy"

#line 52 "parse.xy"
static Expr*
#line 53 "parse.xy"
eunary(Name name, Expr *e1)
#line 54 "parse.xy"
{
#line 55 "parse.xy"
	Expr *e;
#line 56 "parse.xy"
	
#line 57 "parse.xy"
	e = mkExpr(ExprUnary);
#line 58 "parse.xy"
	e->name = name;
#line 59 "parse.xy"
	e->e1 = e1;
#line 60 "parse.xy"
	return e;
#line 61 "parse.xy"
}
#line 62 "parse.xy"

#line 63 "parse.xy"
static char *parsing;
#line 64 "parse.xy"
static Typex *parsedtype;
#line 65 "parse.xy"

#line 66 "parse.xy"
GType*
#line 67 "parse.xy"
parsetype(char *s)
#line 68 "parse.xy"
{
#line 69 "parse.xy"
	char *t;
#line 70 "parse.xy"

#line 71 "parse.xy"
	parsing = s;
#line 72 "parse.xy"
	parsedtype = nil;
#line 73 "parse.xy"
	t = smprint("_PARSETYPE_ %s", s);
#line 74 "parse.xy"
	pushinputstring(t);
#line 75 "parse.xy"
	if(yyparse() != 0 || parsedtype == nil)
#line 76 "parse.xy"
		panic("cannot parse type - %s", s);
#line 77 "parse.xy"
	free(t);
#line 78 "parse.xy"
	parsing = nil;
#line 79 "parse.xy"
	return typegeneralize(typechecktype(nil, parsedtype));
#line 80 "parse.xy"
}
#line 81 "parse.xy"

#line 82 "parse.xy"
static void
#line 83 "parse.xy"
yyerror(char *msg)
#line 84 "parse.xy"
{
#line 85 "parse.xy"
	if(parsing)
#line 86 "parse.xy"
		panic("yyerror parsing %s: %s", parsing, msg);
#line 87 "parse.xy"
	panic("yyerror: %s near %P", msg, yylastpos);
#line 88 "parse.xy"
}
#line 89 "parse.xy"

#line 90 "parse.xy"

#line 745 "parse.xy"
#include "patterncom.h"
#line 746 "parse.xy"

#line 565 "parse.xy"
#include "grammar.h"
#line 566 "parse.xy"
#include "grammarcom.h"
#line 567 "parse.xy"
%}
#line 91 "parse.xy"

#line 92 "parse.xy"
%token <name> '!'
%token <name> L_0 /* "!<" */
%token <name> L_1 /* "!<:" */
%token <name> L_2 /* "!=" */
%token <name> L_3 /* "!~" */
%token <name> '%'
%token <name> L_4 /* "%=" */
%token <name> L_5 /* "%ignore" */
%token <name> L_6 /* "%left" */
%token <name> L_7 /* "%nocopy" */
%token <name> L_8 /* "%nonassoc" */
%token <name> L_9 /* "%prefer" */
%token <name> L_10 /* "%priority" */
%token <name> L_11 /* "%right" */
%token <name> '&'
%token <name> L_12 /* "&&" */
%token <name> L_13 /* "&&=" */
%token <name> L_14 /* "&=" */
%token <name> '('
%token <name> ')'
%token <name> '*'
%token <name> L_15 /* "*=" */
%token <name> '+'
%token <name> L_16 /* "++" */
%token <name> L_17 /* "+=" */
%token <name> ','
%token <name> '-'
%token <name> L_18 /* "--" */
%token <name> L_19 /* "-=" */
%token <name> L_20 /* "->" */
%token <name> '.'
%token <name> L_21 /* ".." */
%token <name> L_22 /* "..." */
%token <name> '/'
%token <name> L_23 /* "/=" */
%token <name> ':'
%token <name> L_24 /* "::" */
%token <name> L_25 /* ":=" */
%token <name> ';'
%token <name> '<'
%token <name> L_26 /* "<:" */
%token <name> L_27 /* "<<" */
%token <name> L_28 /* "<<=" */
%token <name> L_29 /* "<=" */
%token <name> '='
%token <name> L_30 /* "==" */
%token <name> L_31 /* "=>" */
%token <name> '>'
%token <name> L_32 /* ">=" */
%token <name> L_33 /* ">>" */
%token <name> L_34 /* ">>=" */
%token <name> '?'
%token <name> '@'
%token <name> L_35 /* "Ast" */
%token <name> L_36 /* "TYPE" */
%token <name> '['
%token <name> ']'
%token <name> '^'
%token <name> L_37 /* "^=" */
%token <name> L_38 /* "_PARSETYPE_" */
%token <name> L_39 /* "__any__" */
%token <name> '`'
%token <name> L_40 /* "``" */
%token <name> L_ARRAY
%token <name> L_ASSERT
%token <name> L_ASTCOPY
%token <name> L_ASTJOIN
%token <name> L_ASTLASTKID
%token <name> L_ASTLISP
%token <name> L_ASTLONG
%token <name> L_ASTMERGED
%token <name> L_ASTPARENT
%token <name> L_ASTSAME
%token <name> L_ASTSLOT
%token <name> L_ASTSLOTTED
%token <name> L_ASTSPLIT
%token <name> L_ASTUNCOPY
%token <name> L_ATTRIBUTE
%token <name> L_BOOL
%token <name> L_BREAK
%token <name> L_CASE
%token <name> L_CONTINUE
%token <name> L_DESTRUCTURE
%token <name> L_DO
%token <name> L_ELSE
%token <name> L_EXTEND
%token <name> L_EXTENDS
%token <name> L_EXTENSIBLE
%token <name> L_FALSE
%token <name> L_FLOAT
%token <name> L_FMAP
%token <name> L_FN
%token <name> L_FOR
%token <name> L_FROM
%token <name> L_GOTO
%token <name> L_GRAMMAR
%token <name> L_IF
%token <name> L_IMPORT
%token <name> L_IN
%token <name> L_INCLUDE
%token <name> L_INT
%token <name> L_KEYS
%token <name> L_LABEL
%token <name> L_LENGTH
%token <name> L_LIST
%token <name> L_MAP
%token <name> L_NIL
%token <name> L_NODESTRUCTURE
%token <name> L_PARSE
%token <name> L_PRINT
%token <name> L_PTR
%token <name> L_RESTRUCTURE
%token <name> L_RETURN
%token <name> L_STRING
%token <name> L_STRUCT
%token <name> L_SWITCH
%token <name> L_TAG
%token <name> L_TRUE
%token <name> L_TYPEDEF
%token <name> L_WHILE
%token <name> '{'
%token <name> '|'
%token <name> L_41 /* "|=" */
%token <name> L_42 /* "||" */
%token <name> L_43 /* "||=" */
%token <name> '}'
%token <name> '~'
%token	Eof Error

%token	<i>		LInteger

%token	<f>		LFloat

%token	<name>	LName LTypeVar LString

%type <stmt> topstmt

%type <stmt> stmt

%type <stmt> struct

%type <namel> namelist rnamelist

%type <structeleml> decllist rdecllist

%type <structelem> decl

%type <stmt> case

%type <stmtl> zcaselist

%type <stmtl> rcaselist

%type <stmtl> caselist

%type <stmt> stmtfn

%type <stmt> attrfn

%type <name> xstructure

%type <stmt> destructure

%type <stmt> attrdecl

%type <stmtl> stmtlist rstmtlist zstmtlist

%type <expr> constant

%type <expr> name

%type <expr> expr

%type <exprl> rmaplist maplist zmaplist

%type <expr> map

%type <expr> zexpr

%type <exprl> exprlist rexprlist zexprlist

%type <expr> matchexpr

%type <exprl> matchexprlist zmatchexprlist rmatchexprlist

%type <typex> type

%type <typex> dottedtype

%type <typexl> typelist rtypelist ztypelist

%type <fnarg> fnarg

%type <fnargl> fnarglist rfnarglist zfnarglist

%type <typex> zfntype

%token <name> LRegexp

%type <gtop> grammarintro

%type <namel> gextends

%type <gstmtl> gstmtlist rgstmtlist

%type <gstmt> gstmt

%type <grulel> rgrulelist grulelist

%type <grule> grule

%type <name> zgruleprefix

%type <name> zruleprec

%type <name> precitem

%type <gterml> gterms rgterms

%type <gterm> gterm

%token <name> LGTermName

%type <name> gtermname

%type <i> assoc

%type <namel> precitems rprecitems

%type <namel> rprecorder precorder

%type <i> priority

%type <typex> parsename

%type <typex> zparsename

%type <parsepattern> parsepattern

%type <pattoken> pattoken 

%token <pattoken>LPatternText LPatternSlot LPatternEscape

%type <pattokenl> pattokenlist rpattokenlist
#line 93 "parse.xy"

#line 94 "parse.xy"
%pure_parser
#line 95 "parse.xy"
%locations
#line 96 "parse.xy"

#line 97 "parse.xy"
/* %token	Eof Error */
#line 98 "parse.xy"

#line 99 "parse.xy"
/* %token	<i>		LInteger */
#line 100 "parse.xy"
/* %token	<f>		LFloat */
#line 101 "parse.xy"
/* %token	<name>	LName LTypeVar LString */
#line 102 "parse.xy"

#line 103 "parse.xy"
/*
#line 104 "parse.xy"
 * Order of operations.  Similar to, but different from C.
#line 105 "parse.xy"
 * In particular, the bitwise operators have been moved
#line 106 "parse.xy"
 * below the booleans, so that a&4 == b needs no parentheses.
#line 107 "parse.xy"
 *
#line 108 "parse.xy"
 * Also some new operators, like :=.
#line 109 "parse.xy"
 *
#line 110 "parse.xy"
 * The arrow operator for structure dereferencing is gone,
#line 111 "parse.xy"
 * replaced by plain dot.
#line 112 "parse.xy"
 */
#line 113 "parse.xy"
%left Loose
#line 114 "parse.xy"

#line 115 "parse.xy"
%left	L_20 /* "->" */
#line 116 "parse.xy"
%left	L_LIST L_ARRAY L_MAP
#line 117 "parse.xy"

#line 118 "parse.xy"
/*
#line 119 "parse.xy"
 * Tell yacc that when parsing `case n :' to prefer to reduce
#line 120 "parse.xy"
 * the exprname immediately rather than hope for a type to
#line 121 "parse.xy"
 * follow the colon.
#line 122 "parse.xy"
 */
#line 123 "parse.xy"
%left ':'
#line 124 "parse.xy"
%left ExprNamePrec
#line 125 "parse.xy"
%left MatchName
#line 126 "parse.xy"
%left DottedType
#line 127 "parse.xy"

#line 128 "parse.xy"
%left	','
#line 129 "parse.xy"
%right	'=' L_17 /* "+=" */ L_19 /* "-=" */ L_15 /* "*=" */ L_23 /* "/=" */ L_4 /* "%=" */ L_28 /* "<<=" */ L_34 /* ">>=" */ L_14 /* "&=" */ L_37 /* "^=" */ L_41 /* "|=" */ L_13 /* "&&=" */ L_43 /* "||=" */ L_25 /* ":=" */
#line 130 "parse.xy"
%left	L_42 /* "||" */
#line 131 "parse.xy"
%left	L_12 /* "&&" */
#line 132 "parse.xy"
%left	L_30 /* "==" */ '~' L_26 /* "<:" */
#line 133 "parse.xy"
%left	L_2 /* "!=" */ L_3 /* "!~" */ L_1 /* "!<:" */ 
#line 134 "parse.xy"
%left	L_0 /* "!<" */	// bridge lexer gap between ! and !<:
#line 135 "parse.xy"
%left L_21 /* ".." */	// bridge lexer gap between . and ...
#line 136 "parse.xy"
%left	'<' '>' L_29 /* "<=" */ L_32 /* ">=" */
#line 137 "parse.xy"
%left	'|'
#line 138 "parse.xy"
%left	'^'
#line 139 "parse.xy"
%left	'&'
#line 140 "parse.xy"
%left	L_27 /* "<<" */ L_33 /* ">>" */
#line 141 "parse.xy"
%right	L_24 /* "::" */
#line 142 "parse.xy"
%left	'+' '-'
#line 143 "parse.xy"
%left	'*' '/' '%'
#line 144 "parse.xy"
%left	Unary '!'
#line 145 "parse.xy"
%left	L_18 /* "--" */ L_16 /* "++" */ '.' '[' ']' '(' ')'
#line 146 "parse.xy"
%left	LString
#line 147 "parse.xy"
%left	'{' '}'
#line 148 "parse.xy"
%left	'@'
#line 149 "parse.xy"

#line 150 "parse.xy"
%right L_ELSE
#line 151 "parse.xy"

#line 152 "parse.xy"

#line 153 "parse.xy"
%%
#line 154 "parse.xy"

#line 155 "parse.xy"
start:	toplist Eof	{ return 0; }
#line 156 "parse.xy"
|	L_38 /* "_PARSETYPE_" */ type Eof { parsedtype = $2; return 0; }
#line 157 "parse.xy"

#line 158 "parse.xy"
toplist:
#line 159 "parse.xy"
|	toplist top
#line 160 "parse.xy"

#line 161 "parse.xy"
top:	topstmt		{ topstmt($1); }
#line 162 "parse.xy"
|	L_INCLUDE LString ';'	{ pushinputfile(nametostr(findinclude(@$, $2))); }
#line 163 "parse.xy"

#line 164 "parse.xy"
/* %type <stmt> topstmt */
#line 165 "parse.xy"
topstmt:
#line 166 "parse.xy"
	stmt
#line 167 "parse.xy"

#line 168 "parse.xy"
/* %type <stmt> stmt */
#line 169 "parse.xy"
stmt:
#line 170 "parse.xy"
	L_PRINT expr ';'	{ $$ = mkStmt(StmtPrint); $$->e1 = $2; }
#line 171 "parse.xy"
|	zexpr ';'		{ $$ = mkStmt(StmtExpr); $$->e1 = $1; }
#line 172 "parse.xy"
|	'{' zstmtlist '}'	{ $$ = mkStmt(StmtBlock); $$->stmtl = $2; }
#line 173 "parse.xy"
|	L_WHILE '(' expr ')' stmt
#line 174 "parse.xy"
				{ $$ = mkStmt(StmtWhile);
#line 175 "parse.xy"
				  $$->e1 = $3;
#line 176 "parse.xy"
				  $$->s1 = $5;
#line 177 "parse.xy"
				}
#line 178 "parse.xy"
|	L_DO stmt L_WHILE '(' expr ')' ';'
#line 179 "parse.xy"
				{ $$ = mkStmt(StmtDoWhile);
#line 180 "parse.xy"
				  $$->s1 = $2;
#line 181 "parse.xy"
				  $$->e1 = $5;
#line 182 "parse.xy"
				}
#line 183 "parse.xy"
|	L_FOR '(' zexpr ';' zexpr ';' zexpr ')' stmt
#line 184 "parse.xy"
				{ $$ = mkStmt(StmtFor);
#line 185 "parse.xy"
				  $$->e1 = $3;
#line 186 "parse.xy"
				  $$->e2 = $5;
#line 187 "parse.xy"
				  $$->e3 = $7;
#line 188 "parse.xy"
				  $$->s1 = $9;
#line 189 "parse.xy"
				}
#line 190 "parse.xy"
|	L_FOR '(' zexpr L_IN zexpr ')' stmt
#line 191 "parse.xy"
				{ $$ = mkStmt(StmtForIn);
#line 192 "parse.xy"
				  $$->e1 = $3;
#line 193 "parse.xy"
				  $$->e2 = $5;
#line 194 "parse.xy"
				  $$->s1 = $7;
#line 195 "parse.xy"
				}
#line 196 "parse.xy"
|	L_IF '(' expr ')' stmt	{ $$ = mkStmt(StmtIf); $$->e1 = $3; $$->s1 = $5; }
#line 197 "parse.xy"
|	L_IF '(' expr ')' stmt L_ELSE stmt
#line 198 "parse.xy"
				{ $$ = mkStmt(StmtIf);
#line 199 "parse.xy"
				  $$->e1 = $3;
#line 200 "parse.xy"
				  $$->s1 = $5;
#line 201 "parse.xy"
				  $$->s2 = $7;
#line 202 "parse.xy"
				}
#line 203 "parse.xy"
|	stmtfn
#line 204 "parse.xy"
|	attrfn
#line 205 "parse.xy"
|	L_EXTEND attrfn	{ $$ = $2; $$->fn->extend = 1; }
#line 206 "parse.xy"
|	attrdecl
#line 207 "parse.xy"
|	L_EXTENSIBLE stmtfn	{ $$ = $2; $$->fn->extensible = 1; }
#line 208 "parse.xy"
|	L_EXTEND stmtfn	{ $$ = $2; $$->fn->extend = 1; }
#line 209 "parse.xy"
|	L_RETURN zexpr ';'	{ $$ = mkStmt(StmtReturn); $$->e1 = $2; }
#line 210 "parse.xy"
|	L_IMPORT LName ';'	{ $$ = mkStmt(StmtImport); $$->name = $2; }
#line 211 "parse.xy"
|	L_FROM LName L_IMPORT namelist ';'  { $$ = mkStmt(StmtImport); $$->name = $2; $$->namel = $4; }
#line 212 "parse.xy"
|	L_FROM LName L_IMPORT '*' ';'	{ $$ = mkStmt(StmtImport); $$->name = $2; $$->namel = mkNameL($4, nil); }
#line 213 "parse.xy"
|	L_ASSERT expr ';'	{ $$ = mkStmt(StmtAssert); $$->e1 = $2; }
#line 214 "parse.xy"
|	L_BREAK ';'	{ $$ = mkStmt(StmtBreak); }
#line 215 "parse.xy"
|	L_CONTINUE ';'	{ $$ = mkStmt(StmtContinue); }
#line 216 "parse.xy"
|	L_LABEL LName ';'	{ $$ = mkStmt(StmtLabel); $$->name = $2; }
#line 217 "parse.xy"
|	L_GOTO LName ';'	{ $$ = mkStmt(StmtGoto); $$->name = $2; }
#line 218 "parse.xy"
|	L_TYPEDEF LName ':' type ';'	{ $$ = mkStmt(StmtTypedef); $$->name = $2; $$->typex = $4; }
#line 219 "parse.xy"
|	L_SWITCH '(' expr ')' '{' zcaselist '}'	{ $$ = mkStmt(StmtSwitch); $$->e1 = $3; $$->stmtl = $6; }
#line 220 "parse.xy"
|	struct
#line 221 "parse.xy"
|	L_EXTENSIBLE struct	{ $$ = $2; $$->xflag = $1; }
#line 222 "parse.xy"
|	L_EXTEND struct	{ $$ = $2; $$->xflag = $1; }
#line 223 "parse.xy"
|	L_36 /* "TYPE" */ expr ';'	{ $$ = mkStmt(StmtType); $$->e1 = $2; }
#line 224 "parse.xy"

#line 225 "parse.xy"
/* %type <stmt> struct */
#line 226 "parse.xy"
struct:
#line 227 "parse.xy"
	L_STRUCT LName ';'	{ $$ = mkStmt(StmtStruct); $$->name = $2; }	// XXX eliminate
#line 228 "parse.xy"
|	L_STRUCT LName '{' decllist '}'	{ $$ = mkStmt(StmtStruct); $$->name = $2; $$->sel = $4; $$->structinit = 1; }
#line 229 "parse.xy"

#line 230 "parse.xy"
/* %type <namel> namelist rnamelist */
#line 231 "parse.xy"
rnamelist:
#line 232 "parse.xy"
	LName	{ $$ = mkNameL($1, nil); }
#line 233 "parse.xy"
|	rnamelist ',' LName	{ $$ = mkNameL($3, $1); }
#line 234 "parse.xy"

#line 235 "parse.xy"
namelist: rnamelist { $$ = revNameL($1); }
#line 236 "parse.xy"

#line 237 "parse.xy"

#line 238 "parse.xy"

#line 239 "parse.xy"
/* %type <structeleml> decllist rdecllist */
#line 240 "parse.xy"
rdecllist:
#line 241 "parse.xy"
		{ $$ = nil; }
#line 242 "parse.xy"
|	rdecllist decl	{ $$ = mkStructelemL($2, $1); }
#line 243 "parse.xy"

#line 244 "parse.xy"
decllist:	rdecllist { $$ = revStructelemL($1); }
#line 245 "parse.xy"

#line 246 "parse.xy"
/* %type <structelem> decl */
#line 247 "parse.xy"
decl:
#line 248 "parse.xy"
	LName ':' type ';'	{ $$ = mkStructelem();
#line 249 "parse.xy"
		$$->name = $1;
#line 250 "parse.xy"
		$$->typex = $3; }
#line 251 "parse.xy"
|	L_TAG LName '{' decllist '}' ';'	 { $$ = mkStructelem(); $$->tag = 1; $$->name = $2; $$->sel = $4; }
#line 252 "parse.xy"

#line 253 "parse.xy"
/* %type <stmt> case */
#line 254 "parse.xy"
case:
#line 255 "parse.xy"
	L_CASE matchexpr ':' zstmtlist	{ $$ = mkStmt(StmtCase); $$->e1 = $2; $$->stmtl = $4; }
#line 256 "parse.xy"

#line 257 "parse.xy"
/* %type <stmtl> zcaselist */
#line 258 "parse.xy"

#line 259 "parse.xy"
zcaselist: 
#line 260 "parse.xy"
	{ $$ = nil; }
#line 261 "parse.xy"
|	caselist
#line 262 "parse.xy"

#line 263 "parse.xy"
/* %type <stmtl> rcaselist */
#line 264 "parse.xy"
rcaselist:
#line 265 "parse.xy"
	case { $$ = mkStmtL($1, nil); }
#line 266 "parse.xy"
|	rcaselist case { $$ = mkStmtL($2, $1); }
#line 267 "parse.xy"

#line 268 "parse.xy"
/* %type <stmtl> caselist */
#line 269 "parse.xy"
caselist:	rcaselist 	{ $$ = revStmtL($1); }
#line 270 "parse.xy"

#line 271 "parse.xy"
/* %type <stmt> stmtfn */
#line 272 "parse.xy"
stmtfn:
#line 273 "parse.xy"
	L_FN LName '(' zfnarglist ')' zfntype '{' zstmtlist '}'
#line 274 "parse.xy"
				{ Fn *fn;
#line 275 "parse.xy"
				  fn = mkFn($2, $4, $6, $8);
#line 276 "parse.xy"
				  $$ = mkStmt(StmtFn);
#line 277 "parse.xy"
				  $$->fn = fn;
#line 278 "parse.xy"
				}
#line 279 "parse.xy"

#line 280 "parse.xy"
/* %type <stmt> attrfn */
#line 281 "parse.xy"
attrfn:
#line 282 "parse.xy"
	L_ATTRIBUTE LName '(' fnarglist ')' zfntype '{' zstmtlist '}'
#line 283 "parse.xy"
				{ Fn *fn;
#line 284 "parse.xy"
				  fn = mkFn($2, $4, $6, $8);
#line 285 "parse.xy"
				  fn->attribute = 1;
#line 286 "parse.xy"
				  $$ = mkStmt(StmtFn);
#line 287 "parse.xy"
				  $$->fn = fn;
#line 288 "parse.xy"
				}
#line 289 "parse.xy"

#line 290 "parse.xy"
/* could drop these and just require L_FN */
#line 291 "parse.xy"
/* %type <name> xstructure */
#line 292 "parse.xy"
/* %type <stmt> destructure */
#line 293 "parse.xy"
xstructure:
#line 294 "parse.xy"
	L_DESTRUCTURE
#line 295 "parse.xy"
|	L_RESTRUCTURE
#line 296 "parse.xy"
|	L_NODESTRUCTURE
#line 297 "parse.xy"

#line 298 "parse.xy"
destructure:
#line 299 "parse.xy"
	xstructure '(' fnarglist ')' zfntype '{' zstmtlist '}'
#line 300 "parse.xy"
		{
#line 301 "parse.xy"
			Fn *fn;
#line 302 "parse.xy"
			fn = mkFn($1, $3, $5, $7);
#line 303 "parse.xy"
			$$ = mkStmt(StmtFn);
#line 304 "parse.xy"
			$$->fn = fn;
#line 305 "parse.xy"
		}
#line 306 "parse.xy"

#line 307 "parse.xy"
stmt: destructure
#line 308 "parse.xy"

#line 309 "parse.xy"
/* %type <stmt> attrdecl */
#line 310 "parse.xy"
attrdecl:
#line 311 "parse.xy"
	L_ATTRIBUTE	LName '(' typelist ')' zfntype ';'
#line 312 "parse.xy"
		{
#line 313 "parse.xy"
			Typex *t;
#line 314 "parse.xy"
			t = mkTypex(TypexListOne);
#line 315 "parse.xy"
			t->mk.listone = typefn;
#line 316 "parse.xy"
			t->typexl = $4;
#line 317 "parse.xy"
			t->left = $6;
#line 318 "parse.xy"
			$$ = mkStmt(StmtAttrDecl);
#line 319 "parse.xy"
			$$->typex = t;
#line 320 "parse.xy"
			$$->name = $2;
#line 321 "parse.xy"
		}
#line 322 "parse.xy"

#line 323 "parse.xy"
/* %type <stmtl> stmtlist rstmtlist zstmtlist */
#line 324 "parse.xy"
rstmtlist:
#line 325 "parse.xy"
	stmt			{ $$ = mkStmtL($1, nil); }
#line 326 "parse.xy"
|	rstmtlist stmt		{ $$ = mkStmtL($2, $1); }
#line 327 "parse.xy"

#line 328 "parse.xy"
stmtlist:
#line 329 "parse.xy"
	rstmtlist		{ $$ = revStmtL($1); }
#line 330 "parse.xy"

#line 331 "parse.xy"
zstmtlist:
#line 332 "parse.xy"
	{ $$ = nil; }
#line 333 "parse.xy"
|	stmtlist
#line 334 "parse.xy"

#line 335 "parse.xy"
/* %type <expr> constant */
#line 336 "parse.xy"
constant:
#line 337 "parse.xy"
	L_NIL	{ $$ = mkExpr(ExprNil); }
#line 338 "parse.xy"
|	L_TRUE { $$ = mkExpr(ExprBool);  $$->i = 1; }
#line 339 "parse.xy"
|	L_FALSE { $$ = mkExpr(ExprBool); $$->i = 0; }
#line 340 "parse.xy"
|	LInteger	{ $$ = mkExpr(ExprInteger); $$->i = $1; }
#line 341 "parse.xy"
|	LString		{ $$ = mkExpr(ExprString); $$->name = $1; }
#line 342 "parse.xy"
|	LFloat	{ $$ = mkExpr(ExprFloat); $$->f = $1; }
#line 343 "parse.xy"

#line 344 "parse.xy"
/* %type <expr> name */
#line 345 "parse.xy"
name:
#line 346 "parse.xy"
	LName		{ $$ = mkExpr(ExprName); $$->name = $1; }
#line 347 "parse.xy"
	
#line 348 "parse.xy"
/* %type <expr> expr */
#line 349 "parse.xy"
expr:
#line 350 "parse.xy"
	constant
#line 351 "parse.xy"
|	name %prec ExprNamePrec
#line 352 "parse.xy"
|	expr L_2 /* "!=" */ expr	{ $$ = ebinary($2, $1, $3); }
#line 353 "parse.xy"
|	expr L_30 /* "==" */ expr	{ $$ = ebinary($2, $1, $3); }
#line 354 "parse.xy"
|	expr '<' expr	{ $$ = ebinary($2, $1, $3); }
#line 355 "parse.xy"
|	expr '>' expr	{ $$ = ebinary($2, $1, $3); }
#line 356 "parse.xy"
|	expr L_29 /* "<=" */ expr	{ $$ = ebinary($2, $1, $3); }
#line 357 "parse.xy"
|	expr L_32 /* ">=" */ expr	{ $$ = ebinary($2, $1, $3); }
#line 358 "parse.xy"
|	expr '|' expr	{ $$ = ebinary($2, $1, $3); }
#line 359 "parse.xy"
|	expr '^' expr	{ $$ = ebinary($2, $1, $3); }
#line 360 "parse.xy"
|	expr '&' expr	{ $$ = ebinary($2, $1, $3); }
#line 361 "parse.xy"
|	expr L_27 /* "<<" */ expr	{ $$ = ebinary($2, $1, $3); }
#line 362 "parse.xy"
|	expr L_33 /* ">>" */ expr	{ $$ = ebinary($2, $1, $3); }
#line 363 "parse.xy"
|	expr '+' expr	{ $$ = ebinary($2, $1, $3); }
#line 364 "parse.xy"
|	expr '-' expr	{ $$ = ebinary($2, $1, $3); }
#line 365 "parse.xy"
|	expr '*' expr	{ $$ = ebinary($2, $1, $3); }
#line 366 "parse.xy"
|	expr '/' expr	{ $$ = ebinary($2, $1, $3); }
#line 367 "parse.xy"
|	expr '%' expr	{ $$ = ebinary($2, $1, $3); }
#line 368 "parse.xy"
|	expr L_24 /* "::" */ expr	{ $$ = ebinary($2, $1, $3); }
#line 369 "parse.xy"
|	expr L_41 /* "|=" */ expr	{ $$ = ebinaryeq($2, $1, $3); }
#line 370 "parse.xy"
|	expr L_37 /* "^=" */ expr	{ $$ = ebinaryeq($2, $1, $3); }
#line 371 "parse.xy"
|	expr L_14 /* "&=" */ expr	{ $$ = ebinaryeq($2, $1, $3); }
#line 372 "parse.xy"
|	expr L_28 /* "<<=" */ expr	{ $$ = ebinaryeq($2, $1, $3); }
#line 373 "parse.xy"
|	expr L_34 /* ">>=" */ expr	{ $$ = ebinaryeq($2, $1, $3); }
#line 374 "parse.xy"
|	expr L_17 /* "+=" */ expr	{ $$ = ebinaryeq($2, $1, $3); }
#line 375 "parse.xy"
|	expr L_19 /* "-=" */ expr	{ $$ = ebinaryeq($2, $1, $3); }
#line 376 "parse.xy"
|	expr L_15 /* "*=" */ expr	{ $$ = ebinaryeq($2, $1, $3); }
#line 377 "parse.xy"
|	expr L_23 /* "/=" */ expr	{ $$ = ebinaryeq($2, $1, $3); }
#line 378 "parse.xy"
|	expr L_4 /* "%=" */ expr	{ $$ = ebinaryeq($2, $1, $3); }
#line 379 "parse.xy"
|	L_16 /* "++" */ expr	{ $$ = mkExpr(ExprPreInc); $$->e1 = $2; }
#line 380 "parse.xy"
|	L_18 /* "--" */ expr	{ $$ = mkExpr(ExprPreDec); $$->e1 = $2; }
#line 381 "parse.xy"
|	expr L_16 /* "++" */	{ $$ = mkExpr(ExprPostInc); $$->e1 = $1; }
#line 382 "parse.xy"
|	expr L_18 /* "--" */	{ $$ = mkExpr(ExprPostDec); $$->e1 = $1; }
#line 383 "parse.xy"
|	'!' expr	{ $$ = mkExpr(ExprNot); $$->e1 = $2; }
#line 384 "parse.xy"
|	'~' expr %prec Unary	{ $$ = eunary($1, $2); }
#line 385 "parse.xy"
|	'+' expr %prec Unary	{ $$ = eunary($1, $2); }
#line 386 "parse.xy"
|	'-' expr %prec Unary	{ $$ = eunary($1, $2); }
#line 387 "parse.xy"
/* XXX get rid of %prec Unary on these */
#line 388 "parse.xy"
|	L_BOOL '(' expr ')' %prec Unary	{ $$ = eunary($1, $3); }
#line 389 "parse.xy"
|	L_FLOAT '(' expr ')' %prec Unary	{ $$ = eunary($1, $3); }
#line 390 "parse.xy"
|	L_STRING '(' expr ')' %prec Unary	{ $$ = eunary($1, $3); }
#line 391 "parse.xy"
|	L_LENGTH '(' expr ')' %prec Unary	{ $$ = eunary($1, $3); }
#line 392 "parse.xy"
|	L_KEYS '(' expr ')' %prec Unary		{ $$ = eunary($1, $3); }
#line 393 "parse.xy"
|	L_ARRAY '(' expr ')' %prec Unary	{ $$ = eunary($1, $3); }
#line 394 "parse.xy"
|	L_INT '(' expr ')' %prec Unary		{ $$ = eunary($1, $3); }
#line 395 "parse.xy"
|	L_LIST '(' expr ')' %prec Unary		{ $$ = eunary($1, $3); }
#line 396 "parse.xy"
|	LName ':' type	{ $$ = mkExpr(ExprDeclType); $$->name = $1; $$->typex = $3; }
#line 397 "parse.xy"
|	expr L_25 /* ":=" */ expr	{ $$ = mkExpr(ExprDeclAssign); $$->e1 = $1; $$->e2 = $3; }
#line 398 "parse.xy"
|	expr '=' expr	{ $$ = mkExpr(ExprAssign); $$->e1 = $1; $$->e2 = $3; }
#line 399 "parse.xy"
|	expr '(' zexprlist ')'	{ $$ = mkExpr(ExprCall); $$->e1 = $1; $$->el = $3; }
#line 400 "parse.xy"
|	L_22 /* "..." */	{ $$ = mkExpr(ExprDots); }
#line 401 "parse.xy"
|	expr '.' LName	{ $$ = mkExpr(ExprDot); $$->e1 = $1; $$->name = $3; }
#line 402 "parse.xy"
|	expr '~' matchexpr	{ $$ = mkExpr(ExprMatch); $$->e1 = $1; $$->e2 = $3; }
#line 403 "parse.xy"
|	expr L_3 /* "!~" */ matchexpr { $$ = mkExpr(ExprMatch); $$->e1 = $1; $$->e2 = $3; 
#line 404 "parse.xy"
		$1 = $$; $$ = mkExpr(ExprNot); $$->e1 = $1; }
#line 405 "parse.xy"
|	expr L_12 /* "&&" */ expr	{ $$ = mkExpr(ExprAndAnd); $$->e1 = $1; $$->e2 = $3; }
#line 406 "parse.xy"
|	expr L_42 /* "||" */ expr	{ $$ = mkExpr(ExprOrOr); $$->e1 = $1; $$->e2 = $3; }
#line 407 "parse.xy"
|	expr '[' expr ']'	{ $$ = ebinary(N("[]"), $1, $3); }
#line 408 "parse.xy"
|	expr '[' expr ',' ']'	{ $$ = mkExpr(ExprSlice); $$->e1 = $1; $$->e2 = $3; }
#line 409 "parse.xy"
|	expr '[' expr ',' expr ']'	{ $$ = mkExpr(ExprSlice); $$->e1 = $1; $$->e2 = $3; $$->e3 = $5 }
#line 410 "parse.xy"
|	expr L_26 /* "<:" */ type	{ $$ = mkExpr(ExprSubtype); $$->e1= $1; $$->typex = $3; }
#line 411 "parse.xy"
|	expr L_1 /* "!<:" */ type	{ Expr *e; e = mkExpr(ExprSubtype); e->e1 = $1; e->typex = $3; 
#line 412 "parse.xy"
				  $$ = mkExpr(ExprNot); $$->e1 = e; }
#line 413 "parse.xy"
|	L_FN '(' zfnarglist ')' zfntype '{' zstmtlist '}'
#line 414 "parse.xy"
				{ Fn *fn;
#line 415 "parse.xy"
				  fn = mkFn(nil, $3, $5, $7);
#line 416 "parse.xy"
				  $$ = mkExpr(ExprFn);
#line 417 "parse.xy"
				  $$->fn = fn;
#line 418 "parse.xy"
				}
#line 419 "parse.xy"
|	'(' zexprlist ')'	{ if ($2 && !$2->tl) $$ = $2->hd; else { $$ = mkExpr(ExprTuple); $$->el = $2; } }
#line 420 "parse.xy"
|	L_LIST '[' zexprlist ']'	{ $$ = mkExpr(ExprMkList); $$->el = $3; }
#line 421 "parse.xy"
|	L_ARRAY '[' zexprlist ']'	{ $$ = mkExpr(ExprMkArray); $$->el = $3; }
#line 422 "parse.xy"
|	L_FMAP '{' expr ',' zmaplist '}'	{ $$ = mkExpr(ExprMkFmap); $$->el = mkExprL($3, $5); }
#line 423 "parse.xy"
|	L_FMAP '{' zmaplist '}'	{ $$ = mkExpr(ExprMkFmap); $$->el = $3; }
#line 424 "parse.xy"
|	L_MAP '{' zmaplist '}'	{ $$ = mkExpr(ExprMkMap); $$->el = $3; }
#line 425 "parse.xy"
|	L_TAG	'(' expr ')' %prec Unary	{ $$ = mkExpr(ExprTag); $$->e1 = $3; }
#line 426 "parse.xy"
|	L_PTR '(' expr ')' %prec Unary	{ $$ = eunary($1, $3); }
#line 427 "parse.xy"
|	L_ASTSPLIT '(' expr ')'	 { $$ = eunary($1, $3); }
#line 428 "parse.xy"
|	L_ASTMERGED '(' expr ')'	{ $$ = eunary($1, $3); }
#line 429 "parse.xy"
|	L_ASTJOIN '(' expr ',' expr ')'  { $$ = ebinary($1, $3, $5); }
#line 430 "parse.xy"
|	L_ASTCOPY '(' expr ')'	{ $$ = eunary($1, $3); }
#line 431 "parse.xy"
|	L_ASTLASTKID '(' expr ')'	{ $$ = eunary($1, $3); }
#line 432 "parse.xy"
|	L_ASTLISP '(' expr ')'	{ $$ = eunary($1, $3); }
#line 433 "parse.xy"
|	L_ASTLONG '(' expr ')'	{ $$ = eunary($1, $3); }
#line 434 "parse.xy"
|	L_ASTPARENT '(' expr ',' type ')'	{ $$ = eunary($1, $3); $$->typex = $5; }
#line 435 "parse.xy"
|	L_ASTSLOTTED '(' expr ')'	{ $$ = eunary($1, $3); }
#line 436 "parse.xy"
|	L_ASTSLOT '(' expr ',' type ')'	{ $$ = eunary($1, $3); $$->typex = $5; }
#line 437 "parse.xy"
|	L_ASTSAME '(' expr ',' expr ')'	{ $$ = ebinary($1, $3, $5); }
#line 438 "parse.xy"
|	L_ASTUNCOPY '(' expr ')'	{ $$ = eunary($1, $3); }
#line 439 "parse.xy"

#line 440 "parse.xy"
/* %type <exprl> rmaplist maplist zmaplist */
#line 441 "parse.xy"
rmaplist:
#line 442 "parse.xy"
	map		{ $$ = mkExprL($1, nil); }
#line 443 "parse.xy"
|	rmaplist ',' map	{ $$ = mkExprL($3, $1); }
#line 444 "parse.xy"

#line 445 "parse.xy"
maplist: rmaplist	{ $$ = revExprL($1); }
#line 446 "parse.xy"

#line 447 "parse.xy"
zmaplist:
#line 448 "parse.xy"
	{ $$ = nil; }
#line 449 "parse.xy"
|	maplist
#line 450 "parse.xy"

#line 451 "parse.xy"
/* %type <expr> map */
#line 452 "parse.xy"
map:
#line 453 "parse.xy"
	expr L_31 /* "=>" */ expr	{ $$ = mkExpr(ExprMap); $$->e1 = $1; $$->e2 = $3; }
#line 454 "parse.xy"

#line 455 "parse.xy"
/* %type <expr> zexpr */
#line 456 "parse.xy"
zexpr:	{ $$ = nil; }
#line 457 "parse.xy"
|	expr
#line 458 "parse.xy"

#line 459 "parse.xy"
/* %type <exprl> exprlist rexprlist zexprlist */
#line 460 "parse.xy"
rexprlist:
#line 461 "parse.xy"
	expr			{ $$ = mkExprL($1, nil); }
#line 462 "parse.xy"
|	rexprlist ',' expr	{ $$ = mkExprL($3, $1); }
#line 463 "parse.xy"

#line 464 "parse.xy"
exprlist:
#line 465 "parse.xy"
	rexprlist		{ $$ = revExprL($1); }
#line 466 "parse.xy"

#line 467 "parse.xy"
zexprlist:
#line 468 "parse.xy"
	{ $$ = nil; }
#line 469 "parse.xy"
|	exprlist
#line 470 "parse.xy"

#line 471 "parse.xy"
/* %type <expr> matchexpr */
#line 472 "parse.xy"
matchexpr:
#line 473 "parse.xy"
	constant
#line 474 "parse.xy"
|	name %prec MatchName
#line 475 "parse.xy"
|	matchexpr '.' LName	{ $$ = mkExpr(ExprDot); $$->e1 = $1; $$->name = $3; }
#line 476 "parse.xy"
|	matchexpr '(' zmatchexprlist ')'	{ $$ = mkExpr(ExprCall); $$->e1 = $1; $$->el = $3; }
#line 477 "parse.xy"
|	'!' matchexpr	{ $$ = mkExpr(ExprNot); $$->e1 = $2; }
#line 478 "parse.xy"
|	matchexpr L_12 /* "&&" */ matchexpr	{ $$ = mkExpr(ExprAndAnd); $$->e1 = $1; $$->e2 = $3; }
#line 479 "parse.xy"
|	matchexpr L_42 /* "||" */ matchexpr	{ $$ = mkExpr(ExprOrOr); $$->e1 = $1; $$->e2 = $3; }
#line 480 "parse.xy"
|	L_LIST '[' zmatchexprlist ']'	{ $$ = mkExpr(ExprMkList); $$->el = $3; }
#line 481 "parse.xy"
|	L_ARRAY '[' zmatchexprlist ']'	{ $$ = mkExpr(ExprMkArray); $$->el = $3; }
#line 482 "parse.xy"
|	'(' zmatchexprlist ')'	{ if ($2 && !$2->tl) $$ = $2->hd; else { $$ = mkExpr(ExprTuple); $$->el = $2; } }
#line 483 "parse.xy"
|	matchexpr L_24 /* "::" */ matchexpr	{ $$ = ebinary($2, $1, $3); }
#line 484 "parse.xy"
|	name L_25 /* ":=" */ matchexpr %prec Loose	{ $$ = mkExpr(ExprDeclAssign); $$->e1 = $1; $$->e2 = $3; }
#line 485 "parse.xy"
|	L_22 /* "..." */	{ $$ = mkExpr(ExprDots); }
#line 486 "parse.xy"

#line 487 "parse.xy"
/* %type <exprl> matchexprlist zmatchexprlist rmatchexprlist */
#line 488 "parse.xy"
rmatchexprlist:
#line 489 "parse.xy"
	matchexpr	{ $$ = mkExprL($1, nil); }
#line 490 "parse.xy"
|	rmatchexprlist ',' matchexpr	{ $$ = mkExprL($3, $1); }
#line 491 "parse.xy"

#line 492 "parse.xy"
matchexprlist:
#line 493 "parse.xy"
	rmatchexprlist	{ $$ = revExprL($1); }
#line 494 "parse.xy"

#line 495 "parse.xy"
zmatchexprlist:
#line 496 "parse.xy"
	{ $$ = nil; }
#line 497 "parse.xy"
|	matchexprlist
#line 498 "parse.xy"

#line 499 "parse.xy"

#line 500 "parse.xy"
/* %type <typex> type */
#line 501 "parse.xy"
type:
#line 502 "parse.xy"
	L_INT		{ $$ = mkTypex1(typeint()); }
#line 503 "parse.xy"
|	L_FLOAT		{ $$ = mkTypex1(typefloat()); }
#line 504 "parse.xy"
|	L_STRING	{ $$ = mkTypex1(typestring()); }
#line 505 "parse.xy"
|	L_BOOL		{ $$ = mkTypex1(typebool()); }
#line 506 "parse.xy"
|	L_FN '(' ztypelist ')' zfntype
#line 507 "parse.xy"
			{ $$ = mkTypex(TypexListOne); $$->mk.listone = typefn; $$->typexl = $3; $$->left = $5; }
#line 508 "parse.xy"
|	L_LIST type	{ $$ = mkTypex(TypexOne); $$->mk.one = typelist; $$->left = $2; }
#line 509 "parse.xy"
|	L_ARRAY type	{ $$ = mkTypex(TypexOne); $$->mk.one = typearray; $$->left = $2; }
#line 510 "parse.xy"
|	L_MAP '(' type ',' type ')'
#line 511 "parse.xy"
			{ $$ = mkTypex(TypexTwo); $$->mk.two = typemap; $$->left = $3; $$->right = $5; }
#line 512 "parse.xy"
|	L_FMAP '(' type ',' type ')'
#line 513 "parse.xy"
			{ $$ = mkTypex(TypexTwo); $$->mk.two = typefmap; $$->left = $3; $$->right = $5; }
#line 514 "parse.xy"
|	LTypeVar	{ $$ = mkTypex(TypexVar); $$->name = $1; }
#line 515 "parse.xy"
|	'(' ztypelist ')'	{ $$ = mkTypex(TypexList); $$->mk.list = typetuple; $$->typexl = $2; }
#line 516 "parse.xy"
|	L_39 /* "__any__" */	{ $$ = mkTypex1(typeany()); }
#line 517 "parse.xy"
|	dottedtype %prec DottedType
#line 518 "parse.xy"
|	L_35 /* "Ast" */	{ $$ = mkTypex1(typegram1(nil, nil)); }
#line 519 "parse.xy"
|	type '+' type	{ $$ = mkTypex(TypexTwo); $$->mk.two = typegramadd; $$->left = $1; $$->right = $3; }
#line 520 "parse.xy"
|	type '+' '?'	{ $$ = mkTypex(TypexOne); $$->mk.one = typegramquest; $$->left = $1; }
#line 521 "parse.xy"

#line 522 "parse.xy"
/* %type <typex> dottedtype */
#line 523 "parse.xy"
dottedtype:
#line 524 "parse.xy"
	LName	%prec DottedType	{ $$ = mkTypex(TypexName); $$->name = $1; }
#line 525 "parse.xy"
|	dottedtype '.' SETT gtermname CLRT { $$ = mkTypex(TypexDot); $$->left = $1; $$->name = $4; }
#line 526 "parse.xy"

#line 527 "parse.xy"
/* %type <typexl> typelist rtypelist ztypelist */
#line 528 "parse.xy"
rtypelist:
#line 529 "parse.xy"
	type			{ $$ = mkTypexL($1, nil); }
#line 530 "parse.xy"
|	rtypelist ',' type	{ $$ = mkTypexL($3, $1); }
#line 531 "parse.xy"

#line 532 "parse.xy"
typelist: rtypelist		{ $$ = revTypexL($1); }
#line 533 "parse.xy"

#line 534 "parse.xy"
ztypelist:			{ $$ = nil; }
#line 535 "parse.xy"
|	typelist		{ $$ = $1; }
#line 536 "parse.xy"

#line 537 "parse.xy"
/* %type <fnarg> fnarg */
#line 538 "parse.xy"
fnarg:
#line 539 "parse.xy"
	LName ':' type		{ $$ = mkFnarg($1, $3); }
#line 540 "parse.xy"

#line 541 "parse.xy"
/* %type <fnargl> fnarglist rfnarglist zfnarglist */
#line 542 "parse.xy"
rfnarglist:
#line 543 "parse.xy"
	fnarg			{ $$ = mkFnargL($1, nil); }
#line 544 "parse.xy"
|	rfnarglist ',' fnarg	{ $$ = mkFnargL($3, $1); }
#line 545 "parse.xy"

#line 546 "parse.xy"
fnarglist: rfnarglist		{ $$ = revFnargL($1); }
#line 547 "parse.xy"

#line 548 "parse.xy"
zfnarglist:
#line 549 "parse.xy"
	{ $$ = nil; }
#line 550 "parse.xy"
|	fnarglist
#line 551 "parse.xy"

#line 552 "parse.xy"
/* %type <typex> zfntype */
#line 553 "parse.xy"
zfntype:
#line 554 "parse.xy"
			{ $$ = mkTypex(TypexList); $$->mk.list = typetuple; }
#line 555 "parse.xy"
|	':' type	{ $$ = $2; }
#line 556 "parse.xy"

#line 557 "parse.xy"
/****************************** Grammars ********************************/
#line 558 "parse.xy"

#line 559 "parse.xy"
/*
#line 560 "parse.xy"
 * This is the yacc grammar for zeta's grammar statements.
#line 561 "parse.xy"
 * Confusing, I know.
#line 562 "parse.xy"
 */
#line 563 "parse.xy"

#line 564 "parse.xy"
#line 568 "parse.xy"

#line 569 "parse.xy"
/* %token <name> LRegexp */
#line 570 "parse.xy"

#line 571 "parse.xy"
/* unwarranted chumminess with lexer and LALR generator */
#line 572 "parse.xy"
SETG: { assert(yychar == YYEMPTY); ingrammar++; }
#line 573 "parse.xy"
CLRG: { ingrammar--; }
#line 574 "parse.xy"

#line 575 "parse.xy"
SETT: { if(!intermname) assert(yychar == YYEMPTY); intermname++; }
#line 576 "parse.xy"
CLRT: { intermname--; }
#line 577 "parse.xy"

#line 578 "parse.xy"
topstmt:
#line 579 "parse.xy"
	grammarintro '{' SETG gstmtlist CLRG '}'
#line 580 "parse.xy"
	{
#line 581 "parse.xy"
		$$ = mkStmt(StmtGrammar);
#line 582 "parse.xy"
		$1->stmtl = $4;
#line 583 "parse.xy"
		$$->gtop = $1;
#line 584 "parse.xy"
	}
#line 585 "parse.xy"

#line 586 "parse.xy"
/*
#line 587 "parse.xy"
 * Basic grammar rules.
#line 588 "parse.xy"
 */
#line 589 "parse.xy"
/* %type <gtop> grammarintro */
#line 590 "parse.xy"
grammarintro:
#line 591 "parse.xy"
	L_GRAMMAR LName gextends	{ $$ = mkGTop(nil, $2, $3, nil); }
#line 592 "parse.xy"
|	L_EXTENSIBLE L_GRAMMAR LName	{ $$ = mkGTop($1, $3, nil, nil); }
#line 593 "parse.xy"
|	L_EXTEND L_GRAMMAR LName	{ $$ = mkGTop($1, $3, nil, nil); }
#line 594 "parse.xy"

#line 595 "parse.xy"
/* %type <namel> gextends */
#line 596 "parse.xy"
gextends:	{ $$ = nil; }
#line 597 "parse.xy"
|	L_EXTENDS namelist { $$ = $2; }
#line 598 "parse.xy"

#line 599 "parse.xy"
/* %type <gstmtl> gstmtlist rgstmtlist */
#line 600 "parse.xy"
gstmtlist: rgstmtlist { $$ = revGStmtL($1); }
#line 601 "parse.xy"

#line 602 "parse.xy"
rgstmtlist:	{ $$ = nil; }
#line 603 "parse.xy"
|	rgstmtlist gstmt { $$ = mkGStmtL($2, $1); }
#line 604 "parse.xy"

#line 605 "parse.xy"
/* %type <gstmt> gstmt */
#line 606 "parse.xy"
gstmt:
#line 607 "parse.xy"
	gtermname ':' SETT grulelist ';' CLRT
#line 608 "parse.xy"
	{
#line 609 "parse.xy"
		$$ = mkGStmt(GStmtRules);
#line 610 "parse.xy"
		$$->name = $1;
#line 611 "parse.xy"
		$$->rulel = $4;
#line 612 "parse.xy"
	}
#line 613 "parse.xy"

#line 614 "parse.xy"
/* %type <grulel> rgrulelist grulelist */
#line 615 "parse.xy"
grulelist: rgrulelist { $$ = revGRuleL($1); }
#line 616 "parse.xy"
rgrulelist:
#line 617 "parse.xy"
	grule	{ $$ = mkGRuleL($1, nil); }
#line 618 "parse.xy"
|	rgrulelist '|' grule	{ $$ = mkGRuleL($3, $1); }
#line 619 "parse.xy"

#line 620 "parse.xy"
/* %type <grule> grule */
#line 621 "parse.xy"
grule:
#line 622 "parse.xy"
	zgruleprefix gterms zruleprec
#line 623 "parse.xy"
	{
#line 624 "parse.xy"
		$$ = mkGRule();
#line 625 "parse.xy"
		$$->name = $1;
#line 626 "parse.xy"
		$$->terml = $2;
#line 627 "parse.xy"
		$$->prec = $3;
#line 628 "parse.xy"
	}
#line 629 "parse.xy"

#line 630 "parse.xy"
/* %type <name> zgruleprefix */
#line 631 "parse.xy"
zgruleprefix:
#line 632 "parse.xy"
	{ $$ = nil; }
#line 633 "parse.xy"
|	'<' gtermname '>'	{ $$ = $2; }
#line 634 "parse.xy"

#line 635 "parse.xy"
/* %type <name> zruleprec */
#line 636 "parse.xy"
zruleprec:
#line 637 "parse.xy"
	{ $$ = nil; }
#line 638 "parse.xy"
|	'[' CLRT precitem SETT ']'	{ $$ = $3; }
#line 639 "parse.xy"

#line 640 "parse.xy"
/* %type <name> precitem */
#line 641 "parse.xy"
precitem:
#line 642 "parse.xy"
	LName
#line 643 "parse.xy"
|	LGTermName
#line 644 "parse.xy"
|	LString	{ $$ = nameof(cescapestring(nametostr($1), -1, '"')); }
#line 645 "parse.xy"

#line 646 "parse.xy"
/* %type <gterml> gterms rgterms */
#line 647 "parse.xy"
rgterms:
#line 648 "parse.xy"
	{ $$ = nil; }
#line 649 "parse.xy"
|	rgterms gterm { $$ = mkGTermL($2, $1); }
#line 650 "parse.xy"

#line 651 "parse.xy"
gterms: rgterms { $$ = revGTermL($1); }
#line 652 "parse.xy"

#line 653 "parse.xy"
/* %type <gterm> gterm */
#line 654 "parse.xy"
gterm:
#line 655 "parse.xy"
	gtermname /*SETT*/ { $$ = mkGTerm(GTermName); $$->text = $1; }
#line 656 "parse.xy"
|	LString	{ $$ = mkGTerm(GTermString); $$->text = $1; }
#line 657 "parse.xy"
|	LRegexp	{ $$ = mkGTerm(GTermRegexp); $$->text = $1; $$->flags = $<flags>1; }
#line 658 "parse.xy"

#line 659 "parse.xy"
/* %token <name> LGTermName */
#line 660 "parse.xy"
/* %type <name> gtermname */
#line 661 "parse.xy"
gtermname:
#line 662 "parse.xy"
	LGTermName
#line 663 "parse.xy"

#line 664 "parse.xy"

#line 665 "parse.xy"
/*
#line 666 "parse.xy"
 * Associativity.
#line 667 "parse.xy"
 */
#line 668 "parse.xy"

#line 669 "parse.xy"
/* %type <i> assoc */
#line 670 "parse.xy"
assoc:
#line 671 "parse.xy"
	L_6 /* "%left" */	{ $$ = CfgAssocLeft; }
#line 672 "parse.xy"
|	L_11 /* "%right" */	{ $$ = CfgAssocRight; }
#line 673 "parse.xy"
|	L_8 /* "%nonassoc" */	{ $$ = CfgAssocNone; }
#line 674 "parse.xy"

#line 675 "parse.xy"
/* %type <namel> precitems rprecitems */
#line 676 "parse.xy"
rprecitems:
#line 677 "parse.xy"
	precitem	{ $$ = mkNameL($1, nil); }
#line 678 "parse.xy"
|	rprecitems precitem { $$ = mkNameL($2, $1); }
#line 679 "parse.xy"

#line 680 "parse.xy"
precitems: rprecitems { $$ = revNameL($1); }
#line 681 "parse.xy"

#line 682 "parse.xy"
gstmt:
#line 683 "parse.xy"
	assoc precitems ';'
#line 684 "parse.xy"
	{
#line 685 "parse.xy"
		$$ = mkGStmt(GStmtAssoc);
#line 686 "parse.xy"
		$$->assoc = $1;
#line 687 "parse.xy"
		$$->namel = $2;
#line 688 "parse.xy"
	}
#line 689 "parse.xy"

#line 690 "parse.xy"
/*
#line 691 "parse.xy"
 * Priority
#line 692 "parse.xy"
 */
#line 693 "parse.xy"
/* %type <namel> rprecorder precorder */
#line 694 "parse.xy"
rprecorder:
#line 695 "parse.xy"
	precitem	{ $$ = mkNameL($1, nil); }
#line 696 "parse.xy"
|	rprecorder '>' precitem { $$ = mkNameL($3, $1); }
#line 697 "parse.xy"

#line 698 "parse.xy"
precorder: rprecorder { $$ = revNameL($1); }
#line 699 "parse.xy"

#line 700 "parse.xy"
/* %type <i> priority */
#line 701 "parse.xy"
priority:
#line 702 "parse.xy"
	L_10 /* "%priority" */ { $$ = 1; }
#line 703 "parse.xy"
|	L_9 /* "%prefer" */	{ $$ = 0; }
#line 704 "parse.xy"

#line 705 "parse.xy"
gstmt:
#line 706 "parse.xy"
	priority precorder ';' {
#line 707 "parse.xy"
		$$ = mkGStmt(GStmtPriority);
#line 708 "parse.xy"
		$$->prefer = !$1;
#line 709 "parse.xy"
		$$->namel = $2;
#line 710 "parse.xy"
	}
#line 711 "parse.xy"

#line 712 "parse.xy"
/*
#line 713 "parse.xy"
 * Ignore
#line 714 "parse.xy"
 */
#line 715 "parse.xy"
gstmt:
#line 716 "parse.xy"
	L_5 /* "%ignore" */ gterms ';' { $$ = mkGStmt(GStmtIgnore); $$->terml = $2; }
#line 717 "parse.xy"

#line 718 "parse.xy"
/*
#line 719 "parse.xy"
 * No copy
#line 720 "parse.xy"
 */
#line 721 "parse.xy"
gstmt:
#line 722 "parse.xy"
	L_7 /* "%nocopy" */ gterms ';' { $$ = mkGStmt(GStmtNoCopy); $$->terml = $2; }
#line 723 "parse.xy"

#line 724 "parse.xy"

#line 725 "parse.xy"

#line 726 "parse.xy"
/****************************** Simple parse statement ********************************/
#line 727 "parse.xy"

#line 728 "parse.xy"
/* %type <typex> parsename */
#line 729 "parse.xy"
parsename:
#line 730 "parse.xy"
	gtermname	{ $$ = mkTypex(TypexName); $$->name = $1; }
#line 731 "parse.xy"
|	parsename '.' gtermname	{ $$ = mkTypex(TypexDot); $$->left = $1; $$->name = $3; }
#line 732 "parse.xy"

#line 733 "parse.xy"
/* %type <typex> zparsename */
#line 734 "parse.xy"
zparsename:
#line 735 "parse.xy"
	{ $$ = mkTypex(TypexEmpty); }
#line 736 "parse.xy"
|	parsename
#line 737 "parse.xy"

#line 738 "parse.xy"
/* simple parse statement */
#line 739 "parse.xy"
expr:
#line 740 "parse.xy"
	L_PARSE '(' SETT parsename CLRT ',' expr ')'	{ $$ = mkExpr(ExprParse); $$->typex = $4; $$->e1 = $7; }
#line 741 "parse.xy"

#line 742 "parse.xy"
/****************************** Parsing patterns ********************************/
#line 743 "parse.xy"

#line 744 "parse.xy"
#line 747 "parse.xy"

#line 748 "parse.xy"
SETB: { assert(yychar == YYEMPTY); inbacktick++; }
#line 749 "parse.xy"
CLRB: { inbacktick--; }
#line 750 "parse.xy"

#line 751 "parse.xy"
/* %type <parsepattern> parsepattern */
#line 752 "parse.xy"
parsepattern:
#line 753 "parse.xy"
	SETT zparsename CLRT '{' SETB pattokenlist CLRB '}'
#line 754 "parse.xy"
	{
#line 755 "parse.xy"
		$$ = mkParsePattern(); $$->typex = $2; $$->tokenl = $6;
#line 756 "parse.xy"
	}
#line 757 "parse.xy"

#line 758 "parse.xy"
/* %type <pattoken> pattoken  */
#line 759 "parse.xy"
/* %token <pattoken>LPatternText LPatternSlot LPatternEscape */
#line 760 "parse.xy"
pattoken:
#line 761 "parse.xy"
	LPatternText
#line 762 "parse.xy"
|	LPatternSlot
#line 763 "parse.xy"
|	LPatternEscape CLRB '(' expr ')' SETB { $$->expr = $4; }
#line 764 "parse.xy"

#line 765 "parse.xy"
/* %type <pattokenl> pattokenlist rpattokenlist */
#line 766 "parse.xy"
pattokenlist:	rpattokenlist { $$ = revPatTokenL($1); }
#line 767 "parse.xy"

#line 768 "parse.xy"
rpattokenlist:
#line 769 "parse.xy"
	{ $$ = nil; }
#line 770 "parse.xy"
|	rpattokenlist pattoken { $$ = mkPatTokenL($2, $1); }
#line 771 "parse.xy"

#line 772 "parse.xy"
/* restructuring */
#line 773 "parse.xy"
expr:
#line 774 "parse.xy"
	'`' parsepattern	{ $$ = mkExpr(ExprBacktick); $$->pattern = $2; }
#line 775 "parse.xy"
|	L_40 /* "``" */ parsepattern	{ $$ = mkExpr(ExprBacktick2); $$->pattern = $2; }
#line 776 "parse.xy"

#line 777 "parse.xy"
/* destructuring */
#line 778 "parse.xy"
matchexpr:
#line 779 "parse.xy"
	'`' parsepattern	{ $$ = mkExpr(ExprBacktick); $$->pattern = $2; }
#line 780 "parse.xy"
|	L_40 /* "``" */ parsepattern	{ $$ = mkExpr(ExprBacktick2); $$->pattern = $2; }
#line 781 "parse.xy"

